
let PUZZLE_DIFFICULTY;
const PUZZLE_HOVER_TINT = "#009900";
var startTime, endTime;
let count = 0;
let timer = -1;
var _stage;
var _canvas;

var _img;
var _imgresizer;
var _pieces;
var _puzzleWidth;
var _puzzleHeight;
var _pieceWidth;
var _pieceHeight;
var _currentPiece;
var _currentDropPiece;
var _mouse;
let id;
let slider;
let storageStr;
function makeTableHTML(array) {

    for (let key in array) {
        console.log(key, ':', array[key]);
    }
}

const queryString = window.location.search;
console.log("", queryString);
const urlParams = new URLSearchParams(queryString);
id = urlParams.get('id');
slider = urlParams.get('slider');
storageStr=id+"-"+slider;
window.addEventListener("load", function () {
    console.log("ssssg");

    
    console.log("id=", id);
    console.log("slider", slider);

    PUZZLE_DIFFICULTY = slider;
    $.ajax({

        type: "POST",
        url: "get_url.php",
        data: {'id': id},
        success: function (data) {

            init(data);
        }
    });

    var output = document.getElementById("demo");
    getTime();


})

function init(img) {


    _imgresizer = new Image();
    _imgresizer.addEventListener("load", resize, false);
    _imgresizer.src = img;
    console.log("src", _imgresizer.src);
}


function resize(e) {
    var canvas = document.createElement("canvas");

    var containter = document.getElementById("container")
    var MAX_WIDTH = containter.clientWidth / 2;
    var MAX_HEIGHT = ((containter.clientWidth / 2) * _imgresizer.height) / _imgresizer.width;

    var width = _imgresizer.width;
    var height = _imgresizer.height;

    if (width > height) {
        if (width > MAX_WIDTH) {
            height *= MAX_WIDTH / width;
            width = MAX_WIDTH;
        }
    } else {
        if (height > MAX_HEIGHT) {
            width *= MAX_HEIGHT / height;
            height = MAX_HEIGHT;
        }
    }
    canvas.width = width;
    canvas.height = height;

    var ctx = canvas.getContext("2d");
    ctx.drawImage(_imgresizer, 0, 0, width, height);

    var dataurl = canvas.toDataURL("image/png");

    _img = new Image();
    _img.addEventListener("load", onImage, false);
    _img.src = dataurl;
}

function onImage(e) {

    _pieceWidth = Math.floor(_img.width / PUZZLE_DIFFICULTY);
    _pieceHeight = Math.floor(_img.height / PUZZLE_DIFFICULTY);
    _puzzleWidth = _pieceWidth * PUZZLE_DIFFICULTY;
    _puzzleHeight = _pieceHeight * PUZZLE_DIFFICULTY;
    setCanvas();
    initPuzzle();


}

function timerPlay() {
    startTime = new Date();
    count = 0;
    if (timer == -1) {
        timer = setInterval(function () {
            count++;
            document.getElementById("count").innerHTML = count + "s";
        }, 1000);
    }
}

function setCanvas() {
    _canvas = document.getElementById("canvas");
    _canvas.textAlign = "center";
    _stage = _canvas.getContext("2d");
    _canvas.width = _puzzleWidth;
    _canvas.height = _puzzleHeight;
    _canvas.style.border = "1px white";
}

function initPuzzle() {
    _pieces = [];
    _mouse = {x: 0, y: 0};
    _currentPiece = null;
    _currentDropPiece = null;
    _stage.drawImage(
        _img,
        0,
        0,
        _puzzleWidth,
        _puzzleHeight,
        0,
        0,
        _puzzleWidth,
        _puzzleHeight
    );
    createTitle("LET'S START HERE!");
    buildPieces();

}

function createTitle(msg) {
    _stage.fillStyle = "#000000";
    _stage.globalAlpha = 0.4;
    _stage.fillRect(200, _puzzleHeight - 60, _puzzleWidth - 400, 40);
    _stage.fillStyle = "#FFFFFF";
    _stage.globalAlpha = 1;
    _stage.textAlign = "center";
    _stage.textBaseline = "middle";
    _stage.font = "20px Calibri";
    _stage.fillText(msg, _puzzleWidth / 2, _puzzleHeight - 40);
}

function buildPieces() {
    var i;
    var piece;
    var xPos = 0;
    var yPos = 0;
    for (i = 0; i < PUZZLE_DIFFICULTY * PUZZLE_DIFFICULTY; i++) {
        piece = {};
        piece.sx = xPos;
        piece.sy = yPos;
        _pieces.push(piece);
        xPos += _pieceWidth;
        if (xPos >= _puzzleWidth) {
            xPos = 0;
            yPos += _pieceHeight;
        }
    }
    document.onpointerdown = shufflePuzzle;


}

function shufflePuzzle() {
    _pieces = shuffleArray(_pieces);
    _stage.clearRect(0, 0, _puzzleWidth, _puzzleHeight);
    var i;
    var piece;
    var xPos = 0;
    var yPos = 0;
    for (i = 0; i < _pieces.length; i++) {
        piece = _pieces[i];
        piece.xPos = xPos;
        piece.yPos = yPos;
        _stage.drawImage(
            _img,
            piece.sx,
            piece.sy,
            _pieceWidth,
            _pieceHeight,
            xPos,
            yPos,
            _pieceWidth,
            _pieceHeight
        );
        _stage.strokeRect(xPos, yPos, _pieceWidth, _pieceHeight);
        xPos += _pieceWidth;
        if (xPos >= _puzzleWidth) {
            xPos = 0;
            yPos += _pieceHeight;
        }

    }


    document.onpointerdown = timerPlay();
    document.onpointerdown = onPuzzleClick;


}

function onPuzzleClick(e) {

    if (e.layerX || e.layerX == 0) {
        _mouse.x = e.layerX;
        _mouse.y = e.layerY;
    } else if (e.offsetX || e.offsetX == 0) {
        _mouse.x = e.offsetX;
        _mouse.y = e.offsetY;
    }
    console.log(_mouse.x, _mouse.y);
    _currentPiece = checkPieceClicked();
    if (_currentPiece != null) {
        _stage.clearRect(
            _currentPiece.xPos,
            _currentPiece.yPos,
            _pieceWidth,
            _pieceHeight
        );
        _stage.save();
        _stage.globalAlpha = 0.9;
        _stage.drawImage(
            _img,
            _currentPiece.sx,
            _currentPiece.sy,
            _pieceWidth,
            _pieceHeight,
            _mouse.x - _pieceWidth / 2,
            _mouse.y - _pieceHeight / 2,
            _pieceWidth,
            _pieceHeight
        );
        _stage.restore();


        document.onpointermove = updatePuzzle;

        document.onpointerup = pieceDropped;


    }

    console.log("jjjjj");
}

function checkPieceClicked() {
    var i;
    var piece;
    for (i = 0; i < _pieces.length; i++) {
        piece = _pieces[i];
        if (
            _mouse.x < piece.xPos ||
            _mouse.x > piece.xPos + _pieceWidth ||
            _mouse.y < piece.yPos ||
            _mouse.y > piece.yPos + _pieceHeight
        ) {
//PIECE NOT HIT
        } else {
            return piece;
        }
    }
    return null;
}

function updatePuzzle(e) {
    _currentDropPiece = null;
    if (e.layerX || e.layerX == 0) {
        _mouse.x = e.layerX;
        _mouse.y = e.layerY;
    } else if (e.offsetX || e.offsetX == 0) {
        _mouse.x = e.offsetX;
        _mouse.y = e.offsetY;
    }
    _stage.clearRect(0, 0, _puzzleWidth, _puzzleHeight);
    var i;
    var piece;
    for (i = 0; i < _pieces.length; i++) {
        piece = _pieces[i];
        if (piece == _currentPiece) {
            continue;
        }
        _stage.drawImage(
            _img,
            piece.sx,
            piece.sy,
            _pieceWidth,
            _pieceHeight,
            piece.xPos,
            piece.yPos,
            _pieceWidth,
            _pieceHeight
        );
        _stage.strokeRect(piece.xPos, piece.yPos, _pieceWidth, _pieceHeight);
        if (_currentDropPiece == null) {
            if (
                _mouse.x < piece.xPos ||
                _mouse.x > piece.xPos + _pieceWidth ||
                _mouse.y < piece.yPos ||
                _mouse.y > piece.yPos + _pieceHeight
            ) {
//NOT OVER
            } else {
                _currentDropPiece = piece;
                _stage.save();
                _stage.globalAlpha = 0.4;
                _stage.fillStyle = PUZZLE_HOVER_TINT;
                _stage.fillRect(
                    _currentDropPiece.xPos,
                    _currentDropPiece.yPos,
                    _pieceWidth,
                    _pieceHeight
                );
                _stage.restore();
            }
        }
    }
    _stage.save();
    _stage.globalAlpha = 0.6;
    _stage.drawImage(
        _img,
        _currentPiece.sx,
        _currentPiece.sy,
        _pieceWidth,
        _pieceHeight,
        _mouse.x - _pieceWidth / 2,
        _mouse.y - _pieceHeight / 2,
        _pieceWidth,
        _pieceHeight
    );
    _stage.restore();
    _stage.strokeRect(
        _mouse.x - _pieceWidth / 2,
        _mouse.y - _pieceHeight / 2,
        _pieceWidth,
        _pieceHeight
    );
}

function pieceDropped(e) {
    document.onpointermove = null;
    document.onpointerup = null;

    if (_currentDropPiece != null) {
        var tmp = {xPos: _currentPiece.xPos, yPos: _currentPiece.yPos};
        _currentPiece.xPos = _currentDropPiece.xPos;
        _currentPiece.yPos = _currentDropPiece.yPos;
        _currentDropPiece.xPos = tmp.xPos;
        _currentDropPiece.yPos = tmp.yPos;
    }
    resetPuzzleAndCheckWin();
}

function resetPuzzleAndCheckWin() {
    _stage.clearRect(0, 0, _puzzleWidth, _puzzleHeight);
    var gameWin = true;
    var i;
    var piece;
    for (i = 0; i < _pieces.length; i++) {
        piece = _pieces[i];
        _stage.drawImage(
            _img,
            piece.sx,
            piece.sy,
            _pieceWidth,
            _pieceHeight,
            piece.xPos,
            piece.yPos,
            _pieceWidth,
            _pieceHeight
        );
        _stage.strokeRect(piece.xPos, piece.yPos, _pieceWidth, _pieceHeight);
        if (piece.xPos != piece.sx || piece.yPos != piece.sy) {
            gameWin = false;
        }
    }
    if (gameWin) {
        setTimeout(gameOver, 500);
    }
}

function gameOver() {
    timerPause();
    save();
    document.onpointerdown = null;
    document.onpointermove = null;
    document.onpointerup = null;

    initPuzzle();
    setTimeout(function () {

        location.reload(true);
    }, 2500);
}

function shuffleArray(o) {
    for (
        var j, x, i = o.length;
        i;
        j = parseInt(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x
    ) ;
    return o;
}

function timerPause() {
    endTime = new Date();
    var timeDiff = endTime - startTime; //in ms
// strip the ms
    timeDiff /= 1000;

// get seconds
    var seconds = Math.round(timeDiff);
    const id = urlParams.get('id');
    const name = urlParams.get('name');
    console.log(seconds + " seconds");
    $.ajax({

        type: "POST",
        url: "get_time.php",
        data: {
            'seconds': seconds,
            'id': id,
            'name': name
        },
    });
    clearInterval(timer);
    timer = -1;

}

function save() {
    const result = document.getElementById("result");
    const currentDiv = document.getElementById("first");
    result.style.fontSize = '16px';
    result.style.fontFamily = 'Arial';
    result.style.color = "white";
    result.style.padding = '14px 40px';
    result.style.borderRadius = '8px';
    result.style.width = '50%';
    result.align = 'center';
    result.style.marginLeft = 'auto';
    result.style.marginRight = 'auto';
    if (localStorage.getItem(storageStr) == 0 || localStorage.getItem(storageStr) > count || localStorage.getItem(storageStr) == null) {
        localStorage.setItem(storageStr, count);
        const newContent = document.createTextNode("Congratulations!");
        result.style.backgroundColor = '#008CBA';
        result.appendChild(newContent);
    } else {
        const newContent = document.createTextNode("You can do better, best time: "+localStorage.getItem(storageStr)+" s");
        result.style.backgroundColor = '#f44336';
        result.appendChild(newContent);
    }
}

function timerReset() {
    count = 0;
    document.getElementById("count").innerHTML = count;
    localStorage.setItem(storageStr, 0);
}

function getTime() {
    if ((localStorage.getItem(storageStr))) {
        count = localStorage.getItem(storageStr);
        document.getElementById("count").innerHTML = "Best time: " + count+" s";
    }
}