
let PUZZLE_DIFFICULTY = 3;
const PUZZLE_HOVER_TINT = "#009900";
var startTime, endTime;
let count = 0;
let timer = -1;
var _stage;
var _canvas;
let x;
let y;
var _img;
var _imgresizer;
var _pieces;
var _puzzleWidth;
var _puzzleHeight;
var _pieceWidth;
var _pieceHeight;
var _currentPiece;
var _currentDropPiece;
var _mouse;
let id;
let slider;
let storageStr;
let type = "losange";

function makeTableHTML(array) {

    for (let key in array) {
        console.log(key, ':', array[key]);
    }
}

const queryString = window.location.search;
console.log("", queryString);
const urlParams = new URLSearchParams(queryString);
id = urlParams.get('id');
slider = urlParams.get('slider');
storageStr = type + "-" + id + "-" + slider;
window.addEventListener("load", function () {
    PUZZLE_DIFFICULTY = slider;
    $.ajax({

        type: "POST",
        url: "get_url_cropped.php",
        data: {'id': id},

        success: function (data) {


            init(data);
        }
    });
    var output = document.getElementById("demo");
    getTime();


})

function init(img) {


    _imgresizer = new Image();
    _imgresizer.addEventListener("load", resize, false);
    _imgresizer.src = img;
    console.log("src", _imgresizer.src);
}


function resize(e) {
    var canvas = document.createElement("canvas");

    var containter = document.getElementById("container")
    var MAX_WIDTH = containter.clientWidth / 2;
    var MAX_HEIGHT = ((containter.clientWidth / 2) * _imgresizer.height) / _imgresizer.width;
    x = window.innerWidth / 2 - MAX_WIDTH / 2;
    y = window.innerHeight / 2 - MAX_HEIGHT / 2;
    var width = _imgresizer.width;
    var height = _imgresizer.height;

    if (width > height) {
        if (width > MAX_WIDTH) {
            height *= MAX_WIDTH / width;
            width = MAX_WIDTH;
        }
    } else {
        if (height > MAX_HEIGHT) {
            width *= MAX_HEIGHT / height;
            height = MAX_HEIGHT;
        }
    }
    canvas.width = width;
    canvas.height = height;

    var ctx = canvas.getContext("2d");
    ctx.drawImage(_imgresizer, 0, 0, width, height);

    var dataurl = canvas.toDataURL("image/png");

    _img = new Image();
    _img.addEventListener("load", onImage, false);
    _img.src = dataurl;
}

function onImage(e) {

    _pieceWidth = Math.floor(_img.width / PUZZLE_DIFFICULTY);
    _pieceHeight = Math.floor(_img.height / PUZZLE_DIFFICULTY);
    _puzzleWidth = _pieceWidth * PUZZLE_DIFFICULTY;
    _puzzleHeight = _pieceHeight * PUZZLE_DIFFICULTY;
    setCanvas();
    initPuzzle();


}


function timerPlay() {
    startTime = new Date();
    count = 0;
    if (timer == -1) {
        timer = setInterval(function () {
            count++;
            document.getElementById("count").innerHTML = count + "s";
        }, 1000);
    }
}

function setCanvas() {
    _canvas = document.getElementById("canvas");
    _canvas.textAlign = "center";
    _stage = _canvas.getContext("2d");
    _canvas.width = _puzzleWidth * 1.5;
    _canvas.height = _puzzleHeight * 1.5;
    _canvas.style.border = "1px white";
}

function initPuzzle() {
    // _pieces = [];
    _mouse = {x: 0, y: 0};
    _currentPiece = null;
    _currentDropPiece = null;
    _stage.drawImage(
        _img,
        0,
        0,
        _puzzleWidth,
        _puzzleHeight,
        _canvas.width / 2 - _img.width / 2,
        _canvas.height / 2 - _img.height / 2,

        _puzzleWidth,
        _puzzleHeight
    );
    createTitle("LET'S START HERE!");
    buildPieces();

}

function createTitle(msg) {
    _stage.fillStyle = "#000000";
    _stage.globalAlpha = 0.4;
    _stage.fillRect(200, _puzzleHeight - 60 + _canvas.height / 2 - _img.height / 2, _puzzleWidth - 200 + canvas.width / 2 - _img.width / 2, 40);
    _stage.fillStyle = "#FFFFFF";
    _stage.globalAlpha = 1;
    _stage.textAlign = "center";
    _stage.textBaseline = "middle";
    _stage.font = "20px Calibri";
    _stage.fillText(msg, _puzzleWidth / 2 + canvas.width / 2 - _img.width / 2, _puzzleHeight - 40 + _canvas.height / 2 - _img.height / 2);
}

class Piece {
    constructor(rowIndex, colIndex) {
        this.rowIndex = rowIndex;
        this.colIndex = colIndex;


        this.x = (_puzzleWidth * this.colIndex / PUZZLE_DIFFICULTY) + canvas.width / 2 - _img.width / 2;
        this.y = (_puzzleHeight * this.rowIndex / PUZZLE_DIFFICULTY) + _canvas.height / 2 - _img.height / 2;
        this.width = Math.floor(_img.width / PUZZLE_DIFFICULTY);
        this.height = Math.floor(_img.height / PUZZLE_DIFFICULTY);
        this.xCorrect = this.x;
        this.yCorrect = this.y;
        this.correct = true;

    }

    draw(context) {
        context.beginPath();

        const sz = Math.min(this.width, this.height);
        const neck = 0.05 * sz;
        const tabWidth = 0.3 * sz;
        const tabHeight = 0.3 * sz;

        //from top left
        context.moveTo(this.x, this.y);
        //to top right
        if (this.top) {
            context.lineTo(this.x + this.width * Math.abs(this.top) - neck,
                this.y);
            context.bezierCurveTo(
                this.x + this.width * Math.abs(this.top) - neck,
                this.y - tabHeight * Math.sign(this.top) * 0.2,

                this.x + this.width * Math.abs(this.top) - tabWidth,
                this.y - tabHeight * Math.sign(this.top),

                this.x + this.width * Math.abs(this.top),
                this.y - tabHeight * Math.sign(this.top)
            );

            context.bezierCurveTo(
                this.x + this.width * Math.abs(this.top) + tabWidth,
                this.y - tabHeight * Math.sign(this.top),

                this.x + this.width * Math.abs(this.top) + neck,
                this.y - tabHeight * Math.sign(this.top) * 0.2,

                this.x + this.width * Math.abs(this.top) + neck,
                this.y
            );
        }
        context.lineTo(this.x + this.width, this.y);

        //to bottom right
        if (this.right) {
            context.lineTo(this.x + this.width, this.y + this.height * Math.abs(this.right) - neck);
            context.bezierCurveTo(
                this.x + this.width - tabHeight * Math.sign(this.right) * 0.2,
                this.y + this.height * Math.abs(this.right) - neck,

                this.x + this.width - tabHeight * Math.sign(this.right),
                this.y + this.height * Math.abs(this.right) - tabWidth,

                this.x + this.width - tabHeight * Math.sign(this.right),
                this.y + this.height * Math.abs(this.right)
            );
            context.bezierCurveTo(
                this.x + this.width - tabHeight * Math.sign(this.right),
                this.y + this.height * Math.abs(this.right) + tabWidth,

                this.x + this.width - tabHeight * Math.sign(this.right) * 0.2,
                this.y + this.height * Math.abs(this.right) + neck,

                this.x + this.width,
                this.y + this.height * Math.abs(this.right) + neck
            );
        }
        context.lineTo(this.x + this.width, this.y + this.height);

        //to bottom left
        if (this.bottom) {
            context.lineTo(this.x + this.width * Math.abs(this.bottom) + neck,
                this.y + this.height)

            context.bezierCurveTo(
                this.x + this.width * Math.abs(this.bottom) + neck,
                this.y + this.height + tabHeight * Math.sign(this.bottom) * 0.2,

                this.x + this.width * Math.abs(this.bottom) + tabWidth,
                this.y + this.height + tabHeight * Math.sign(this.bottom),

                this.x + this.width * Math.abs(this.bottom),
                this.y + this.height + tabHeight * Math.sign(this.bottom)
            );

            context.bezierCurveTo(
                this.x + this.width * Math.abs(this.bottom) - tabWidth,
                this.y + this.height + tabHeight * Math.sign(this.bottom),

                this.x + this.width * Math.abs(this.bottom) - neck,
                this.y + this.height + tabHeight * Math.sign(this.bottom) * 0.2,

                this.x + this.width * Math.abs(this.bottom) - neck,
                this.y + this.height
            );
        }
        context.lineTo(this.x, this.y + this.height);

        //to top left
        if (this.left) {
            context.lineTo(this.x, this.y + this.height * Math.abs(this.left) + neck);

            context.bezierCurveTo(
                this.x + tabHeight * Math.sign(this.left) * 0.2,
                this.y + this.height * Math.abs(this.left) + neck,

                this.x + tabHeight * Math.sign(this.left),
                this.y + this.height * Math.abs(this.left) + tabWidth,

                this.x + tabHeight * Math.sign(this.left),
                this.y + this.height * Math.abs(this.left)
            );

            context.bezierCurveTo(
                this.x + tabHeight * Math.sign(this.left),
                this.y + this.height * Math.abs(this.left) - tabWidth,

                this.x + tabHeight * Math.sign(this.left) * 0.2,
                this.y + this.height * Math.abs(this.left) - neck,

                this.x,
                this.y + this.height * Math.abs(this.left) - neck
            );
        }
        context.lineTo(this.x, this.y);

        context.save();
        context.clip();


        const scaledTabHeight =
            Math.min(_img.width / PUZZLE_DIFFICULTY,
                _img.height / PUZZLE_DIFFICULTY) * tabHeight / sz;
        context.globalAlpha = 1;
        context.drawImage(_img,
            this.colIndex * _img.width / PUZZLE_DIFFICULTY
            - scaledTabHeight,
            this.rowIndex * _img.height / PUZZLE_DIFFICULTY
            - scaledTabHeight,
            _img.width / PUZZLE_DIFFICULTY
            + scaledTabHeight * 2,
            _img.height / PUZZLE_DIFFICULTY
            + scaledTabHeight * 2,
            this.x - tabHeight,
            this.y - tabHeight,
            this.width + tabHeight * 2,
            this.height + tabHeight * 2);
        console.log("volte drawimage");

        context.restore();

        context.stroke();
    }

    snap() {
        console.log("SNAP");

        this.x = this.xCorrect;
        this.y = this.yCorrect;
        this.correct = true;
        console.log(this.x, this.y);

    }

    isClose() {
        if (phytagoras({x: this.x, y: this.y},
            {x: this.xCorrect, y: this.yCorrect}) < this.width / 3) {
            return true;
        }
        return false;
    }
}

function buildPieces() {
    var i;
    //var piece;
    _pieces = [];
    var xPos = 0;
    var yPos = 0;
    for (i = 0; i < PUZZLE_DIFFICULTY; i++) {
        for (let j = 0; j < PUZZLE_DIFFICULTY; j++) {

            _pieces.push(new Piece(i, j));
            xPos += _pieceWidth;
            if (xPos >= _puzzleWidth) {
                xPos = 0;
                yPos += _pieceHeight;
            }
            _pieces[i].x += _pieceWidth;
            if (_pieces[i].x >= _puzzleWidth) {
                _pieces[i].x = 0;
                _pieces[i].y += _pieceHeight;
            }
            console.log("array", _pieces.length)
        }
    }
    //verificare dove inserire il tab in base alla posizione del pezzo
    let cnt = 0;
    for (let i = 0; i < PUZZLE_DIFFICULTY; i++) {
        for (let j = 0; j < PUZZLE_DIFFICULTY; j++) {
            let piece = _pieces[cnt];
            if (i == PUZZLE_DIFFICULTY - 1) {
                piece.bottom = null;
            } else {
                let sgn = (Math.random() - 0.5) < 0 ? -1 : 1;
                piece.bottom = sgn * (Math.random() * 0.4 + 0.3);
            }
            if (j == PUZZLE_DIFFICULTY - 1) {
                piece.right = null;
            } else {
                let sgn = (Math.random() - 0.5) < 0 ? -1 : 1;
                piece.right = sgn * (Math.random() * 0.4 + 0.3);
            }
            if (j == 0) {
                piece.left = null;
            } else {
                piece.left = -_pieces[cnt - 1].right;
            }
            if (i == 0) {
                piece.top = null;
            } else {
                piece.top = -_pieces[cnt - PUZZLE_DIFFICULTY].bottom;
            }

            cnt++;
            console.log(_pieces);
        }
    }
    document.onpointerdown = shufflePuzzle;

}

function shufflePuzzle() {

    _pieces = shuffleArray(_pieces);

    _stage.clearRect(0, 0, _canvas.width, _canvas.height);
    _stage.globalAlpha = 0.3;
    _stage.drawImage(
        _img,
        0,
        0,
        _puzzleWidth,
        _puzzleHeight,
        _canvas.width / 2 - _img.width / 2,
        _canvas.height / 2 - _img.height / 2,
        _puzzleWidth,
        _puzzleHeight
    );
    var i;
    var piece;
    var xPos = 0;
    var yPos = 0;


    for (let j = 0; j < _pieces.length; j++) {
        _pieces[j].draw(_stage);


    }


    //
    for (i = 0; i < _pieces.length; i++) {
        piece = _pieces[i];
        piece.xPos = xPos;
        piece.yPos = yPos;


    }


    document.onpointerdown = timerPlay();
    document.onpointerdown = onPuzzleClick;
}

function shuffleArray(o) {

    for (let i = 0; i < o.length; i++) {
        let loc = {
            x: Math.random() * (canvas.width - _pieceWidth),
            y: Math.random() * (canvas.height - _pieceHeight)
        }
        o[i].x = loc.x;


        o[i].y = loc.y;

        o[i].correct = false;

    }
    return o;
}

function onPuzzleClick(e) {

    if (e.layerX || e.layerX == 0) {
        _mouse.x = e.layerX;
        _mouse.y = e.layerY;
    } else if (e.offsetX || e.offsetX == 0) {
        _mouse.x = e.offsetX;
        _mouse.y = e.offsetY;
    }

    console.log(_mouse.x, _mouse.y);
    _currentPiece = checkPieceClicked();
    if (_currentPiece != null) {
        _stage.clearRect(
            _currentPiece.x,
            _currentPiece.y,
            _pieceWidth,
            _pieceHeight
        );
        const index = _pieces.indexOf(_currentPiece);
        if (index > -1) {
            //in modo da evitare che i pezzi vengano sovrapposti l'indice viene aggiornato
            _pieces.splice(index, 1);
            _pieces.push(_currentPiece);
        }
        _currentPiece.offset = {
            x: _mouse.x - _currentPiece.x,
            y: _mouse.y - _currentPiece.y
        }
        _currentPiece.correct = false;

        _stage.clearRect(0, 0, _canvas.width, _canvas.height);

        _stage.globalAlpha = 0.3;
        _stage.drawImage(
            _img,
            0, 0,
            _puzzleWidth,
            _puzzleHeight,
            _canvas.width / 2 - _img.width / 2,
            _canvas.height / 2 - _img.height / 2,
            _puzzleWidth,
            _puzzleHeight
        );
        for (let j = 0; j < _pieces.length; j++) {
            _pieces[j].draw(_stage);
        }

        document.onpointermove = updatePuzzle;

        document.onpointerup = pieceDropped;
    }

}

function checkPieceClicked() {
    var i;
    //var piece;
    for (i = _pieces.length - 1; i >= 0; i--) {

        if (
            _mouse.x < _pieces[i].x ||
            _mouse.x > _pieces[i].x + _pieceWidth ||
            _mouse.y < _pieces[i].y ||
            _mouse.y > _pieces[i].y + _pieceHeight
        ) {
            //PIECE NOT HIT
        } else {
            return _pieces[i];
        }
    }
    return null;
}

function updatePuzzle(e) {
    _currentDropPiece = null;
    if (e.layerX || e.layerX == 0) {
        _mouse.x = e.layerX;
        _mouse.y = e.layerY;
    } else if (e.offsetX || e.offsetX == 0) {
        _mouse.x = e.offsetX;
        _mouse.y = e.offsetY;
    }

    _stage.clearRect(0, 0, _canvas.width, _canvas.height);

    _stage.globalAlpha = 0.3;
    _stage.drawImage(
        _img,
        0,
        0,
        _puzzleWidth,
        _puzzleHeight,
        _canvas.width / 2 - _img.width / 2,
        _canvas.height / 2 - _img.height / 2,
        _puzzleWidth,
        _puzzleHeight
    );
    var i;
    for (i = 0; i < _pieces.length; i++) {

        //NOT OVER
        if (_currentDropPiece == null) {
            if (
                _mouse.x < _pieces[i].x ||
                _mouse.x > _pieces[i].x + _pieceWidth ||
                _mouse.y < _pieces[i].y ||
                _mouse.y > _pieces[i].y + _pieceHeight
            ) {

            } else {
                if (_currentPiece != null) {


                    _currentPiece.x = _mouse.x - _currentPiece.offset.x;
                    _currentPiece.y = _mouse.y - _currentPiece.offset.y;


                }
            }

        }
    }
    _stage.clearRect(0, 0, _canvas.width, _canvas.height);

    _stage.globalAlpha = 0.3;
    _stage.drawImage(
        _img,
        0,
        0,
        _puzzleWidth,
        _puzzleHeight,
        _canvas.width / 2 - _img.width / 2,
        _canvas.height / 2 - _img.height / 2,
        _puzzleWidth,
        _puzzleHeight
    );
    for (let j = 0; j < _pieces.length; j++) {
        _pieces[j].draw(_stage);


    }
    return _currentPiece;
}

function theEnd() {
    for (let i = 0; i < _pieces.length; i++) {
        if (_pieces[i].correct == false) {
            console.log(_pieces[i].correct);
            gameWin = false;
            return false;
        }
    }
    return true;
}

function pieceDropped(e) {

    document.onpointermove = null;
    document.onpointerup = null;
    if (_currentPiece && _currentPiece.isClose()) {

        _currentPiece.snap();

    }

    theEnd();
    _currentPiece = null;

    if (theEnd()) {
        console.log("vittoria");
        resetPuzzleAndCheckWin()
    }
    ;

}

function phytagoras(c1, c2) {
    return Math.sqrt(
        (c1.x - c2.x) * (c1.x - c2.x) +
        (c1.y - c2.y) * (c1.y - c2.y));
}

function resetPuzzleAndCheckWin() {
    _stage.clearRect(0, 0, _canvas.width, _canvas.height);

    var gameWin = true;
    var i;
    var piece;
    for (let j = 0; j < _pieces.length; j++) {
        _pieces[j].draw(_stage);


    }

    for (i = 0; i < _pieces.length; i++) {
        piece = _pieces[i];
        _stage.drawImage(
            _img,
            piece.sx,
            piece.sy,
            _pieceWidth,
            _pieceHeight,
            piece.xPos,
            piece.yPos,
            _pieceWidth,
            _pieceHeight
        );

    }
    if (gameWin) {
        setTimeout(gameOver, 500);
    }
}

function gameOver() {
    timerPause();
    save();
    document.onpointerdown = null;
    document.onpointermove = null;
    document.onpointerup = null;
    initPuzzle();
    setTimeout(function () {

        location.reload(true);
    }, 2500);
}

function timerPause() {
    endTime = new Date();
    var timeDiff = endTime - startTime; //in ms
    // strip the ms
    timeDiff /= 1000;

    // get seconds 
    var seconds = Math.round(timeDiff);
    const id = urlParams.get('id');
    const name = urlParams.get('name');
    console.log(seconds + " seconds");
    $.ajax({

        type: "POST",
        url: "get_time.php",
        data: {
            'seconds': seconds,
            'id': id,
            'name': name
        },
        success: function (data) {

            makeTableHTML(data);
        }
    });
    clearInterval(timer);
    timer = -1;

}

function save() {

    const result = document.getElementById("result");
    const currentDiv = document.getElementById("first");

    result.style.fontSize = '16px';
    result.style.fontFamily = 'Arial';
    result.style.color = "white";
    result.style.padding = '14px 40px';
    result.style.borderRadius = '8px';
    result.style.width = '50%';
    result.align = 'center';
    result.style.marginLeft = 'auto';
    result.style.marginRight = 'auto';
    if (localStorage.getItem(storageStr) == 0 || localStorage.getItem(storageStr) > count || localStorage.getItem(storageStr) == null) {
        localStorage.setItem(storageStr, count);
        const newContent = document.createTextNode("Congratulations!");
        result.style.backgroundColor = '#008CBA';

        result.appendChild(newContent);

    } else {

        const newContent = document.createTextNode("You can do better, best time: " + localStorage.getItem(storageStr) + " s");
        result.style.backgroundColor = '#f44336';

        result.appendChild(newContent);
    }
}

function timerReset() {

    count = 0;
    document.getElementById("count").innerHTML = count;
    localStorage.setItem(storageStr, 0);

}

function getTime() {
    if ((localStorage.getItem(storageStr))) {
        count = localStorage.getItem(storageStr);
        document.getElementById("count").innerHTML = "Best time: " + count + " s";
    }
}